import java.util.Comparator;

public class Person implements Comparable<Person>, Comparator<Person> {
    private Firstname firstname;
    private Origin origin;
    private Size size;
    private Weight weight;
    private Eye eye;

    Person(Firstname firstname, Origin origin, Size size, Weight weight, Eye eye) {
        setFirstname(firstname);
        setOrigin(origin);
        setPersonSize(size);
        setWeight(weight);
        setEye(eye);
    }

    public void setFirstname(Firstname firstname) {
        this.firstname = firstname;
    }

    public Firstname getFirstname() {
        return firstname;
    }

    public void setOrigin(Origin origin) {
        this.origin = origin;
    }

    public Origin getOrigin() {
        return origin;
    }

    public void setPersonSize(Size size) {
        this.size = size;
    }

    public Size getPersonSize() {
        return size;
    }

    public void setWeight(Weight weight) {
        this.weight = weight;
    }

    public Weight getWeight() {
        return weight;
    }

    public void setEye(Eye eye) {
        this.eye = eye;
    }

    public Eye getEye() {
        return eye;
    }

    @Override
    public int compareTo(Person person) {
        return this.firstname.compareTo(person.getFirstname()) + this.origin.compareTo(person.getOrigin())
                + this.size.compareTo(person.getPersonSize()) + this.weight.compareTo(person.getWeight())
                + this.eye.compareTo(person.getEye());
    }

    @Override
    public int compare(Person p1, Person p2) {
        return p1.compareTo(p2);
    }
}
